package com.dayou.brokerage.handler;

import com.dayou.bo.BrokerageDetailBO;
import com.dayou.brokerage.BrokerageCalculateSupport;
import com.dayou.brokerage.BrokerageCalculator;
import com.dayou.brokerage.Factory.BrokerageCalculateFactory;
import com.dayou.brokerage.config.BrokerageMarketerRatioSet;
import com.dayou.brokerage.constants.BrokerageRule;
import com.dayou.dto.ItemDTO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;

/**
 * 类说明：
 *
 * @author: wucl
 * @since: 2023/3/6
 * created with IntelliJ IDEA.
 */
@Component
@Slf4j
public class MarketerBrokerageHandler extends BrokerageCalculateSupport implements BrokerageCalculator{

    @Autowired
    private BrokerageMarketerRatioSet brokerageMarketerRatioSet;

    @Override
    public BigDecimal predictAmount(ItemDTO itemDTO) {
//        BrokerageDetailBO brokerageDetailBO = new BrokerageDetailBO();
//        brokerageDetailBO.setItemBrokerageStatus("CLOSED");
//        checkItemBrokerageStatus(brokerageDetailBO);
//        checkMarketerPredictBrokerage(brokerageDetailBO);
        String mergeKey = itemDTO.mergeKey();
        BigDecimal ratio = brokerageMarketerRatioSet.getRatioList().get(mergeKey);
        if (itemDTO.getAmount()!=null && ratio !=null){
            return itemDTO.getAmount().multiply(ratio);
        }
        return BigDecimal.ZERO;
    }

    @Override
    public BigDecimal actualAmount(ItemDTO itemDTO) {
        return null;
    }

    @Override
    public BigDecimal advanceAmount() {
        return null;
    }

    @Override
    public BigDecimal residueAmount() {
        return null;
    }


}
